#include "StdAfx.h"
#include "MusicFile.h"

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		MMLfile* MML	llkt@C̃IuWFNg
//	Ԓl
//				
//==============================================================
MusicFile::MusicFile(MMLfile* MML, const char _strName[]):
	MusicItem(_strName),
	Header(MML)
{
	//----------------------
	//Localϐ


//	萔`
enum	Command_ID_MusicFile {
	//NSF Header
	id_include,
	id_Title,
	id_Composer,
	id_Copyright,
	id_bgm_num,
	id_se_num,

	id_Segment,
	id_Code,

	id_OctaveReverse,

	//Block
	id_Envelop,
	id_Macro,
	id_Sub,
	id_BGM,
	id_SE
};

//	́AMML\ŎgR}hB
const	static	Command_Info	Command[] = {
		{	"#Include",			id_include		},
		{	"#include",			id_include		},
		{	"#Title",			id_Title		},
		{	"#title",			id_Title		},
		{	"#Composer",		id_Composer		},
		{	"#composer",		id_Composer		},
		{	"#Copyright",		id_Copyright	},
		{	"#copyright",		id_Copyright	},
		{	"#Segment",			id_Segment		},
		{	"#segment",			id_Segment		},
		{	"#Code",			id_Code			},
		{	"#code",			id_Code			},
		{	"#OctaveReverse",	id_OctaveReverse},
		{	"#octaveReverse",	id_OctaveReverse},
		{	"#BGM",				id_bgm_num		},
		{	"#bgm",				id_bgm_num		},
		{	"#SE",				id_se_num		},
		{	"#se",				id_se_num		},
		{	"Envelop",			id_Envelop		},
		{	"envelop",			id_Envelop		},
		{	"$",				id_Macro		},
		{	"Sub",				id_Sub			},
		{	"sub",				id_Sub			},
		{	"BGM",				id_BGM			},
		{	"bgm",				id_BGM			},
		{	"SE",				id_SE			},
		{	"se",				id_SE			},
	};

	unsigned	int			i;
	unsigned	char		cData;
				Envelop*	_env;
				BGM*		_bgm;
				SE*			_se;
				Sub*		_sub;
	string		msg;

	map<	int,	Envelop*	>::iterator	itEnvelop;
	map<	int,	BGM*		>::iterator	itBGM;
	map<	int,	SE*			>::iterator	itSE;
	map<	int,	Sub*		>::iterator	itSub;

	iSize = 0;

	do{
		
		//Pǂݍ݁iRg`FbNAincludet@C̏I[`FbNj
		cData = MML->GetChar();

		//[EOF]`FbN
		if( MML->eom() ){
			break;
		}

		//P߂
		MML->StreamPointerAdd(-1);

		//R}h̃`FbN
		switch(MML->GetCommandID(Command, sizeof(Command)/sizeof(Command_Info))){
			case(id_include):
				MML->include();
				break;
			case(id_Title):
				Header.Set_Title(MML);
				break;
			case(id_Composer):
				Header.Set_Composer(MML);
				break;
			case(id_Copyright):
				Header.Set_Copyright(MML);
				break;
			case(id_Segment):
				Header.Set_Segment(MML);
				break;
			case(id_Code):
				Header.Set_RomCode(MML);
				break;
			case(id_OctaveReverse):
				MML->octave_reverse = true;		//́AMMLt@C̑B
				break;
			case(id_bgm_num):
				Header.Set_Number_BGM(MML);
				break;
			case(id_se_num):
				Header.Set_Number_SE(MML);
				break;
			case(id_Envelop):
				i = MML->GetNum();
				//d`FbN
				if(ptcEnv.count(i) != 0){
					MML->Err("Envelop()ubNœԍw肳܂B");
				}
				_env = new Envelop(MML);
				ptcItem.push_back(_env);
				ptcEnv[i] = _env;
				iSize += _env->getSize();	//BGM̃TCYXV
				break;
			case(id_Sub):
				i = MML->GetNum();
				//d`FbN
				if(ptcSub.count(i) != 0){
					MML->Err("Sub()ubNœԍw肳܂B");
				}
				//͈̓`FbN
				_sub = new Sub(MML);
				ptcItem.push_back(_sub);
				ptcSub[i] = _sub;
				iSize += _sub->getSize();	//BGM̃TCYXV
				break;
			case(id_BGM):
				i = MML->GetNum();
				//d`FbN
				if(ptcBGM.count(i) != 0){
					MML->Err("BGM()ubNœԍw肳܂B");
				}
				//͈̓`FbN
				if((Header.iBGM <= i) || (i<0)){
					MML->Err("BGM()ubNŎwł͈͂𒴂Ă܂B\n#BGM̐lmFĂB");
				}
				_bgm = new BGM(MML);
				ptcItem.push_back(_bgm);
				ptcBGM[i] = _bgm;
				iSize += _bgm->getSize();	//BGM̃TCYXV
				break;
			case(id_SE):
				i = MML->GetNum();
				//d`FbN
				if(ptcSE.count(i) != 0){
					MML->Err("SE()ubNœԍw肳܂B");
				}
				//͈̓`FbN
				if((Header.iSE <= i) || (i<0)){
					MML->Err("SE()ubNŎwł͈͂𒴂Ă܂B\n#SE̐lmFĂB");
				}
				_se = new SE(MML);
				ptcItem.push_back(_se);
				ptcSE[i] = _se;
				iSize += _se->getSize();	//BGM̃TCYXV
				break;
			default:
				MML->Err("unknown command");
				break;
		}
		
	} while( !MML->eom() );

	//Check
	if( Header.iBGM + Header.iSE > 255){
		Err("BGMSE̐Av255z܂B");
	}

	i = 0;
	while(i < Header.iBGM){
		if(ptcBGM.count(i) == 0){
			Err("BGMf[^܂B");
		};
		i++;
	}

	i = 0;
	while(i < Header.iSE){
		if(ptcSE.count(i) == 0){
			Err("SE f[^܂B");
		};
		i++;
	}

}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
MusicFile::~MusicFile(void)
{

}

//==============================================================
//		AhX肷B
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::Fix_Address(void)
{
	map<int,Sub*	>::iterator	itSub;

	unsigned	int			iBGM	= 0;
	unsigned	int			iSE		= 0;

	while(iBGM < Header.iBGM){
		ptcBGM[iBGM]->Fix_Address(&ptcSub, &ptcEnv);
		iBGM++;
	}
	while(iSE < Header.iSE){
		ptcSE[iSE]->Fix_Address(&ptcSub, &ptcEnv);
		iSE++;
	}

	if(!ptcSub.empty()){
		itSub = ptcSub.begin();
		while(itSub != ptcSub.end()){
			itSub->second->Fix_Address(&ptcSub, &ptcEnv);
			itSub++;
		}
	}
}

//==============================================================
//		
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::init_romimg(void)
{
	memset(romimg, 0, sizeof(romimg));

}

//==============================================================
//		ȃoCiC[W̍쐬
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::make_binary(void)
{
	string	_str;
	unsigned	int			i		= 2;
	unsigned	int			iBGM	= 0;
	unsigned	int			iSE		= 0;
	unsigned	__int16*	pt;

	unsigned	int		_size	= 4 + (Header.iBGM + Header.iSE)*2;

	_str.clear();
	_str.resize(_size);

	pt = (unsigned __int16*)_str.c_str();

	_str[0] = Header.iBGM;
	_str[1] = Header.iSE;
	pt[1]	=	0;			//PCM info ̃AhX

	while(iBGM < Header.iBGM){
		pt[i] = 0x8000 + _size + ptcBGM[iBGM]->getOffset();
		i++;
		iBGM++;
	}
	while(iSE < Header.iSE){
		pt[i] = 0x8000 + _size + ptcSE[iSE]->getOffset();
		i++;
		iSE++;
	}

	getCode(&_str);
	code = _str;
}
		
//==============================================================
//		mre̍쐬
//--------------------------------------------------------------
//	
//		const char*	strFileName	R[h
//	Ԓl
//				
//==============================================================
void	MusicFile::make_nsf(const char*	strFileName)
{
	FileInput*	_romcode	= new FileInput();
	_romcode->fileopen(strFileName);

	unsigned	__int16*	_nsd_init	=	((unsigned	__int16*)romimg) + 0x7FF0/sizeof(unsigned	__int16);
	unsigned	__int16*	_nsd_main	=	((unsigned	__int16*)romimg) + 0x7FF2/sizeof(unsigned	__int16);

	//ROMC[WɃoCi[]
	init_romimg();
	memcpy((char *)romimg, code.c_str(), code.size());

	_romcode->read((char*)(romimg + 0x6000), 0x2000);
	_romcode->close();	

	//NSFwb_[̍쐬
	nsf.Name[0]			= 'N';
	nsf.Name[1]			= 'E';
	nsf.Name[2]			= 'S';
	nsf.Name[3]			= 'M';
	nsf.Name[4]			= 0x1A;
	nsf.Version			= 1;
	nsf.MusicNumber		= Header.iBGM + Header.iSE;
	nsf.StartMusicNumber= 1;
	nsf.LoadAddress		= 0x8000;
	nsf.InitAddress		= *_nsd_init;
	nsf.MainAddress		= *_nsd_main;
	nsf.Frequency_NTSC	= 0x411A;
	nsf.Frequency_PAL	= 0x4E20;
	nsf.Video			= 0;
	nsf.External		= 0;
	nsf.Bank[0]			= 0;
	nsf.Bank[1]			= 0;
	nsf.Bank[2]			= 0;
	nsf.Bank[3]			= 0;
	nsf.Bank[4]			= 0;
	nsf.Bank[5]			= 0;
	nsf.Bank[6]			= 0;
	nsf.Bank[7]			= 0;
	nsf.Null1			= 0;
	nsf.Null2			= 0;
	nsf.Null3			= 0;
	nsf.Null4			= 0;

	memcpy(&nsf.Title, Header.title.c_str(), 32);
	memcpy(&nsf.Composer, Header.composer.c_str(), 32);
	memcpy(&nsf.Copyright, Header.copyright.c_str(), 32);

	delete	_romcode;
}

//==============================================================
//		oCit@Cւ̕ۑ
//--------------------------------------------------------------
//	
//		const char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
void	MusicFile::saveBIN(const char*	strFileName)
{
	//----------------------
	//File open
	fileopen(strFileName);

	write(code.c_str(), code.size());
	//----------------------
	//Close file
	close();
}

//==============================================================
//		mre`ւ̕ۑ
//--------------------------------------------------------------
//	
//		const char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
void	MusicFile::saveNSF(const char*	strFileName)
{
	//----------------------
	//File open
	fileopen(strFileName);

	make_nsf(Header.romcode.c_str());
	write((char*)&nsf, sizeof(nsf));
	write(romimg, sizeof(romimg));

	//----------------------
	//Close file
	close();
}

//==============================================================
//		AZu\[Xւ̕ۑ
//--------------------------------------------------------------
//	
//		const char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
void	MusicFile::saveASM(const char*	strFileName)
{
	//----------------------
	//File open
	fileopen(strFileName);

	//----------------------
	//Close file
	close();
}

//==============================================================
//		b\[Xւ̕ۑ
//--------------------------------------------------------------
//	
//		const char*	strFileName		t@C
//	Ԓl
//				
//==============================================================
void	MusicFile::saveC(const char*	strFileName)
{
	//----------------------
	//File open
	fileopen(strFileName);

	//----------------------
	//Close file
	close();
}

//==============================================================
//		G[
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::Err(const char* msg)
{
	cout << "[ ERROR ] : " << msg << endl;

	//ُI
	exit(-1);
}

//==============================================================
//		[jO
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
void	MusicFile::Warning(const char* msg)
{
	//݂̃t@CƁAs\
	cout << "[WARNING] : " << msg << endl;
}
